#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back
using namespace std;
const int maxn = 1e5 + 50;
map<int, vector<int>> mp;
map<int, vector<pii>> r;

map<int, int> used;
map<int, int> ban;
vi path;
vi ans;

int dfs(int v, int to) {
	used[v] = 1;
	if (v == to)
		return 1;
	bool ok = 0;
	for (auto &u : r[v]) {
		if (!used[u.s]) {
			path.pb(u.f);
			if (dfs(u.s, to)) {
				ok = 1;
				break;
			}
			path.pop_back();
		}
	}
	return ok;
}

int dfs2(int v) {
	for (auto &u : r[v]) {
		if (!ban[u.f]) {
			ban[u.f] = 1;
			ans.pb(u.f + 1);
			return dfs2(u.s);
		}
	}
	return v;
}

void solve() {
	int n;
	cin >> n;
	pii a[n];
	int dist = -1;
	for (int i = 0; i < n; ++i) {
        int m, s;
        cin >> m >> s;
        vi p;
        for (int j = 0; j < m; ++j) {
			int x;
			cin >> x;
			p.pb(x);
        }
        for (int j = 1; j < p.size(); ++j) {
			if (dist == -1) {
				dist = p[j] - p[j - 1];
			} else if (dist != p[j] - p[j - 1]) {
				cout << "No\n";
				exit(0);
			}
        }
        a[i] = {p[0], s - p.back()};
	}

	if (n == 1) {
		cout << "Yes\n1\n";
		exit(0);
	}
	assert(dist != -1);
	vi v;
	for (int i = 0; i < n; ++i) {
 		v.pb(a[i].s);
		mp[a[i].f].pb(i);
	}
	sort(v.begin(), v.end());
	v.resize(unique(v.begin(), v.end()) - v.begin());
	map<int, int> s;
	int cnt = 0;
	int used[n];
	memset(used, 0, sizeof(used));
	for (auto &i : v) {
		for (auto &u : mp[dist - i]) {
			//cout << i << ' ' << a[u].s << "(" << u << ")\n";
			r[i].pb({u, a[u].s});
			used[u] = 1;
			cnt++;
			s[i]++;
			s[a[u].s]--;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			r[-1].pb({i, a[i].s});
			s[-1]++;
			s[a[i].s]--;
			cnt++;
		}
	}
	int cntp = 0, cntm = 0;
	for (auto &u : s) {
		if (abs(u.s) > 1) {
			cerr << "BIG STEPEN VERSINI" << '\n';
			cout << "No\n";
			exit(0);
		}
		cntp += (u.s > 0);
		cntm += (u.s < 0);
	}
	cerr << "CNT: +" << cntp << "  -" << cntm << '\n';
	if (cntp + cntm > 2 || cntp > 1 || cntm > 1 || (cntp + cntm) % 2 || cnt < n) {
		cerr << "MNOGO STEPENIH VERSIN" << '\n';
		cout << "No" << '\n';
		exit(0);
	}
	int start = v[0];
	if (cntp)
		for (auto &u : s)
			if (u.s > 0)
				start = u.f;
	int last = start;
	if (cntm)
		for (auto &u : s)
			if (u.s < 0)
				last = u.f;
	dfs(start, last);
	for (auto &i : path) {
		ban[i] = 1;
	}
	vi path2;
	path2.pb(start);
	for (auto &i : path) {
		//cout << i + 1 << ' ';
		path2.pb(a[i].s);
	}
	//cout << '\n';
	for (int i = 0; i < path2.size(); ++i) {
		for (auto &u : r[path2[i]]) {
			if (!ban[u.f]){
				ban[u.f] = 1;
				ans.pb(u.f + 1);

				dfs2(u.s);
			}
		}
		if (i < path.size())
			ans.pb(path[i] + 1);
	}
	bool ok = 1;
	for (int i = 0; i < n; ++i) {
		ok &= ban[i];
	}
	if (!ok) {
		cout << "No\n";
		exit(0);
	}
	cout << "Yes\n";
	for (auto &i : ans)
		cout << i << ' ';
	cout << '\n';
}

signed main()
{
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(10);
    int t;
    t = 1;
    while (t--)
    solve();
    return 0;
}
