#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back
using namespace std;
const int maxn = 1e5 + 50;
const int mod = 1e9 + 7;

int fastpow(int a, int b) {
	if (b == 0)
		return 1;
	if (b & 1)
		return fastpow(a, b - 1) * a % mod;
	int t = fastpow(a, b / 2);
	return t * t % mod;
};

void solve() {

	string a, b, c;
	cin >> a >> b >> c;
	int n = a.size();
    pii v[n];
    int bcnt[2][2];
    memset(bcnt, 0, sizeof(bcnt));
    for (int i = 0; i < n; ++i) {
		int A = a[i] - '0';
		int B = b[i] - '0';
		int C = c[i] - '0';
		int l = 0, r = 0;
		if ((A + B) % 10 == C)
			r = 0;
		else if ((A + B + 1) % 10 == C) {
			r = 1;
		} else {
			cout << 0 << '\n';
			exit(0);
		}
		if ((A + B + r) / 10 < 1)
			l = 0;
		else if ((A + B + r) / 10 >= 1) {
			l = 1;
		}
		bcnt[l][r] += (A == 0 || B == 0 || C == 0);
		v[i] = {l, r};
    }

/*
	int n;
    cin >> n;
    pii v[n];
    for (auto &i : v)
		cin >> i.f >> i.s;*/
    int cnt[2][2];
    memset(cnt, 0, sizeof(cnt));
    for (auto &i : v)
		cnt[i.f][i.s]++;
	int f[n + 5];
	f[0] = 1;
	for (int i = 1; i <= n + 4; ++i) {
		f[i] = f[i - 1] * i % mod;
	}
	auto cnk = [&] (int n, int k) {
		return f[n] * fastpow(f[k], mod - 2) % mod * fastpow(f[n - k], mod - 2) % mod;
	};
	int dp[n + 3][n + 3];
	memset(dp, 0, sizeof(dp));
	fill(dp[0], dp[0] + n + 3, 1);
	for (int i = 1; i <= n + 2; ++i)
		dp[1][i] = i;
	for (int i = 2; i <= n + 2; ++i) {
		for (int j = 1; j <= n + 2; ++j) {
			for (int k = 0; k <= i; ++k) {
				dp[i][j] += dp[i - k][j - 1];
				dp[i][j] %= mod;
			}
		}
	}
	/*
	for (int i = 1; i <= n + 1; ++i) {
		for (int j = 1; j <= n + 1; ++j)
			cout << dp[i][j] << ' ';
		cout << '\n';
	}
	*/
	if (cnt[0][1] == cnt[1][0]) {
		int lans = 0;
        for (int k = 0; k < cnt[0][1] - bcnt[0][1]; ++k) {
			cnt[0][1]--;
			swap(cnt[1][0], cnt[0][1]);
			swap(cnt[0][0], cnt[1][1]);
			int c0 = cnt[0][1];
			int c1 = cnt[0][1];
			int ans = 1;
			ans = ans * dp[cnt[1][1]][c1] % mod;
			ans = ans * dp[cnt[0][0]][c0] % mod;
			//cout << ans << '\n';
			ans = ans * f[cnt[0][0]] % mod * f[cnt[0][1]] % mod * f[cnt[1][1]] % mod* f[cnt[1][0]] % mod;
			lans += ans;
			lans %= mod;
			swap(cnt[1][0], cnt[0][1]);
			swap(cnt[0][0], cnt[1][1]);
			cnt[0][1]++;
        }
        for (int k = 0; k < cnt[0][0] - bcnt[0][0]; ++k) {
        	cnt[0][0]--;
			int c0 = cnt[0][1] + 1;
			int c1 = cnt[0][1];
			int ans = 1;
			ans = ans * dp[cnt[1][1]][c1] % mod;
			ans = ans * dp[cnt[0][0]][c0] % mod;
			//cout << ans << '\n';
			ans = ans * f[cnt[0][0]] % mod * f[cnt[0][1]] % mod * f[cnt[1][1]] % mod* f[cnt[1][0]] % mod;
			lans += ans;
			lans %= mod;
			cnt[0][0]++;
        }
		cout << lans << '\n';
	} else if (cnt[0][1] == cnt[1][0] + 1) {
		cout << 0 << '\n';
		exit(0);
        int lans = 0;
        for (int k = 0; k < cnt[0][1] - bcnt[0][1]; ++k) {
			cnt[0][1]--;
			swap(cnt[1][0], cnt[0][1]);
			swap(cnt[0][0], cnt[1][1]);
			int c0 = cnt[0][1] + 1;
			int c1 = cnt[0][1];
			int ans = 1;
			ans = ans * dp[cnt[1][1]][c1] % mod;
			ans = ans * dp[cnt[0][0]][c0] % mod;
			//cout << ans << '\n';
			ans = ans * f[cnt[0][0]] % mod * f[cnt[0][1]] % mod * f[cnt[1][1]] % mod* f[cnt[1][0]] % mod;
			lans += ans;
			lans %= mod;
			swap(cnt[1][0], cnt[0][1]);
			swap(cnt[0][0], cnt[1][1]);
			cnt[0][1]++;
        }
        for (int k = 0; k < cnt[0][0] - bcnt[0][0]; ++k) {
        	cnt[0][0]--;
			int c0 = cnt[0][1];
			int c1 = cnt[0][1];
			int ans = 1;
			ans = ans * dp[cnt[1][1]][c1] % mod;
			ans = ans * dp[cnt[0][0]][c0] % mod;
			//cout << ans << '\n';
			ans = ans * f[cnt[0][0]] % mod * f[cnt[0][1]] % mod * f[cnt[1][1]] % mod* f[cnt[1][0]] % mod;
			lans += ans;
			lans %= mod;
			cnt[0][0]++;
        }
		cout << lans << '\n';
	} else {
		cout << 0 << '\n';
	}
}

signed main()
{
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("outgood.txt", "w", stdout);
	#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(10);
    int t;
    t = 1;
    while (t--)
		solve();
    return 0;
}
